unit VoiceCommandAutoCallBackImplU;

{$ifdef CONDITIONALEXPRESSIONS}
{$WARN SYMBOL_PLATFORM OFF}
{$endif}

interface

uses
  ComObj, ActiveX, VoiceCommandAuto_TLB, StdVcl;

type
  TListenCallBack = class(TAutoObject, IListenCallBack)
  protected
    procedure CommandOther(const sCommand, sApp, sState: WideString); safecall;
    procedure CommandRecognize(const sCommand: WideString; ID: Integer);
      safecall;
  public
    procedure Initialize; override;
    destructor Destroy; override;
  end;

implementation

uses ComServ, VoiceCommandAutoU, Messages;

procedure TListenCallBack.Initialize;
begin
  inherited;
  frmVoiceCommandAutomation.Log('Callback created')
end;

destructor TListenCallBack.Destroy;
begin
  frmVoiceCommandAutomation.Log('Callback destroyed');
  inherited;
end;

procedure TListenCallBack.CommandOther(const sCommand, sApp,
  sState: WideString);
begin
  frmVoiceCommandAutomation.Log('Other command: %s, app: %s, state: %s', [sCommand, sApp, sState]);
end;

procedure TListenCallBack.CommandRecognize(const sCommand: WideString;
  ID: Integer);
begin
  frmVoiceCommandAutomation.Log('Our command: %s, id: %d', [sCommand, ID]);
  frmVoiceCommandAutomation.Perform(WM_COMMAND, ID, 0)
end;

initialization
  TAutoObjectFactory.Create(ComServer, TListenCallBack, Class_ListenCallBack,
    ciMultiInstance, tmApartment);
  //Ensure error not shown regarding callback object still being alive
  //(it will be destroyed by the server when the server gets destroyed
  //during our shutdown)
  ComServer.UIInteractive := False
end.
