unit VoiceCommandAutoVarCallBackImplU;

{$ifdef CONDITIONALEXPRESSIONS}
{$WARN SYMBOL_PLATFORM OFF}
{$endif}

interface

uses
  ComObj, ActiveX, VoiceCommandAutoVar_TLB, StdVcl;

type
  TListenCallback = class(TAutoObject, IListenCallback)
  protected
    procedure CommandRecognize(const sCommand: WideString; ID: Integer);
      safecall;
    procedure CommandOther(const sCommand, sApp, sState: WideString); safecall;
  public
    procedure Initialize; override;
    destructor Destroy; override;
  end;

implementation

uses ComServ, VoiceCommandAutoVarU, Messages;

procedure TListenCallback.Initialize;
begin
  inherited;
  frmVoiceCommandAutomation.Log('Callback created')
end;

destructor TListenCallback.Destroy;
begin
  frmVoiceCommandAutomation.Log('Callback destroyed');
  inherited;
end;

procedure TListenCallback.CommandRecognize(const sCommand: WideString;
  ID: Integer);
begin
  frmVoiceCommandAutomation.Log('Our command: %s, id: %d', [sCommand, ID]);
  frmVoiceCommandAutomation.Perform(WM_COMMAND, ID, 0)
end;

procedure TListenCallback.CommandOther(const sCommand, sApp,
  sState: WideString);
begin
  if sCommand <> '' then
    frmVoiceCommandAutomation.Log(
      'Other command: %s, app: %s, state: %s', [sCommand, sApp, sState])
  else
    frmVoiceCommandAutomation.Log('Other command: unrecognised utterance')
end;

initialization
  TAutoObjectFactory.Create(ComServer, TListenCallback, Class_ListenCallback,
    ciMultiInstance, tmApartment);
  //Ensure error not shown regarding callback object still being alive
  //(it will be destroyed by the server when the server gets destroyed
  //during our shutdown)
  ComServer.UIInteractive := False
end.
