unit VoiceTextAutoCallBackImplU;

{$ifdef CONDITIONALEXPRESSIONS}
{$WARN SYMBOL_PLATFORM OFF}
{$endif}

interface

uses
  ComObj, ActiveX, VoiceTextAuto_TLB, StdVcl;

type
  TVoiceCallback = class(TAutoObject, IVoiceCallback)
  protected
    procedure SpeakingStarted; safecall;
    procedure SpeakingDone; safecall;
  public
    procedure Initialize; override;
    destructor Destroy; override;
  end;

implementation

uses ComServ, VoiceTextAutoU;

procedure TVoiceCallback.Initialize;
begin
  inherited;
  frmVTxtAutoEarlyBound.Log('Voice callback being created');
end;

destructor TVoiceCallback.Destroy;
begin
  frmVTxtAutoEarlyBound.Log('Voice callback being destroyed');
  inherited;
end;

procedure TVoiceCallback.SpeakingStarted;
begin
  frmVTxtAutoEarlyBound.Log('Event: speech has started');
end;

procedure TVoiceCallback.SpeakingDone;
begin
  frmVTxtAutoEarlyBound.Log('Event: speech has stopped');
end;

initialization
  TAutoObjectFactory.Create(ComServer, TVoiceCallback, Class_VoiceCallback,
    ciMultiInstance, tmApartment);
  //Ensure error not shown regarding callback object still being alive
  //(it will be destroyed by the server when the server gets destroyed
  //during our shutdown)
  ComServer.UIInteractive := False
end.
