unit VoiceTextAutoU;

//Uses the high level VTxtAuto Automation object,
//with early bound access through the IVTxtAuto interface
//defined in the vtxtauto.tlb type library (VTxtAuto_TLB.pas)

interface

uses
  VTxtAuto_TLB,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ActnList, ComCtrls, Buttons, ImgList, ToolWin;

type
  TfrmVTxtAutoEarlyBound = class(TForm)
    lstProgress: TListBox;
    Label1: TLabel;
    ImageList1: TImageList;
    memText: TMemo;
    ToolBar1: TToolBar;
    btnPlay: TToolButton;
    btnPause: TToolButton;
    btnStop: TToolButton;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnPlayClick(Sender: TObject);
    procedure btnPauseClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
  private
    VTxt: IVTxtAuto;
    BeenPaused: Boolean;
  public
    procedure Log(const Msg: String); overload;
    procedure Log(const Msg: String; const Args: array of const); overload;
  end;

var
  frmVTxtAutoEarlyBound: TfrmVTxtAutoEarlyBound;

implementation

{$R *.dfm}

uses
  ComObj;

{ TfrmSAPITest }

procedure TfrmVTxtAutoEarlyBound.Log(const Msg: String);
begin
  if not Assigned(lstProgress) then
    Exit;
  lstProgress.Items.Add(Msg);
  lstProgress.ItemIndex := lstProgress.Items.Count - 1
end;

procedure TfrmVTxtAutoEarlyBound.Log(const Msg: String; const Args: array of const);
begin
  Log(Format(Msg, Args))
end;

procedure TfrmVTxtAutoEarlyBound.FormCreate(Sender: TObject);
begin
  SendMessage(lstProgress.Handle, LB_SETHORIZONTALEXTENT, Width, 0);
  //VTxt := CreateOleObject('Speech.VoiceText') as IVTxtAuto;
  //VTxt := CoVTxtAuto_.Create;
  VTxt := CreateComObject(CLASS_VTxtAuto_) as IVTxtAuto;
  VTxt.Register('', Application.ExeName);
  //The callback object specified by the ProgID
  //below implements the notification interface
  VTxt.Callback := 'VoiceTextAuto.VoiceCallback';
end;

procedure TfrmVTxtAutoEarlyBound.btnPlayClick(Sender: TObject);
begin
  if not BeenPaused then
    VTxt.Speak(memText.Text, 0)
  else
  begin
    VTxt.AudioResume;
    BeenPaused := False
  end
end;

procedure TfrmVTxtAutoEarlyBound.btnPauseClick(Sender: TObject);
begin
  if Bool(VTxt.IsSpeaking) then
  begin
    VTxt.AudioPause;
    BeenPaused := True
  end
end;

procedure TfrmVTxtAutoEarlyBound.btnStopClick(Sender: TObject);
begin
  VTxt.StopSpeaking;
end;

end.
