unit VoiceTextAutoVarReadWordDocU;

//Uses the VTxtAuto Automation object, with late bound access through a Variant
//Opens a Word document and reads it aloud (uses Word.Basic and has some issues
//so it needs to be translated to VBA)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ComCtrls, ToolWin, StdCtrls;

type
  TfrmVTxtAutoLateBound = class(TForm)
    btnReadDoc: TButton;
    dlgOpenDoc: TOpenDialog;
    btnStop: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnReadDocClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    VTxt, MSWord: Variant;
  end;

var
  frmVTxtAutoLateBound: TfrmVTxtAutoLateBound;

implementation

{$R *.dfm}

uses
  ComObj, ClipBrd;

{ TfrmSAPITest }

procedure TfrmVTxtAutoLateBound.FormCreate(Sender: TObject);
begin
  VTxt := CreateOleObject('Speech.VoiceText');
  VTxt.Register('', Application.ExeName);
  MSWord := CreateOleObject('Word.Application');
end;

procedure TfrmVTxtAutoLateBound.btnReadDocClick(Sender: TObject);
const
// Constants for enum WdUnits
  wdCharacter = $00000001;
  wdParagraph = $00000004;
// Constants for enum WdMovementType
  wdExtend = $00000001;
var
  Moved: Integer;
  Txt: String;
begin
  (Sender as TButton).Enabled := False;
  if dlgOpenDoc.Execute then
  begin
    MSWord.Documents.Open(FileName := dlgOpenDoc.FileName);
    Moved := 2;
    while Moved > 1 do
    begin
      //Select next paragraph
      Moved := MSWord.Selection.EndOf(Unit:=wdParagraph, Extend:=wdExtend);
      if Moved > 1 then
      begin
        //It makes sense to read the selected text directly, but it
        //gives problems with long text, so we use the clipboard instead
{$define USE_SELECTION}
{$ifdef USE_SELECTION}
        Txt := Trim(MSWord.Selection.Text);
{$else}
        MSWord.Selection.Copy;
        Txt := Trim(ClipBoard.AsText);
{$endif}
        if Length(Txt) > 0 then
          VTxt.Speak(pszBuffer := Txt, dwFlags := 0);
        Application.ProcessMessages;
        //Move to start of next paragraph
        MSWord.Selection.MoveRight(Unit:=wdCharacter);
      end
    end;
  end;
  MSWord.ActiveDocument.Close;
  TButton(Sender).Enabled := True;
end;

procedure TfrmVTxtAutoLateBound.btnStopClick(Sender: TObject);
begin
  if VTxt.IsSpeaking then
    VTxt.StopSpeaking
end;

procedure TfrmVTxtAutoLateBound.FormDestroy(Sender: TObject);
begin
  btnStop.Click;
  MSWord.Quit;
  MSWord := Unassigned;
end;

end.
